module Teste

  class << self
  @@path_to_resources = File.join(File.dirname(__FILE__), 'Resources')

  def colorchange
      mat_names = ['Color']
      materials = Sketchup.active_model.materials
      mat_names.each{|mn| materials.add(mn) unless materials[mn]}
      mat_folder = File.join(File.dirname(__FILE__).tr("\\","/"),"Materials/Color/")
      @last ||= '0'
      @last=='7' ? @last='1' :  @last=@last.next
      for mn in mat_names
      material = materials[mn]
      material.texture = mat_folder + "#{@last}-#{mn}.jpg"
      end
   end
      
   def componentchange
      @@mod = Sketchup.active_model
      @@ent = @@mod.active_entities
      @@avant = Sketchup.active_model.get_attribute("component","Last","1")
	  @@next = @@avant.next
	  @@next = '1' if @@next == '4'	
	  
      @@last1 = "#{@@avant}-Component"
	  @@next_name = "#{@@next}-Component"
	  
   if @@mod.definitions.find{|d|d.name=~/#{@@last1}?/}
      @@cd = @@mod.definitions.find{|d|d.name=~/#{@@next_name}?/}
   unless @@cd
      cmp = File.join(Sketchup.find_support_file('plugins'),"TNT_Teste/Components/#{@@next_name}.skp")
      @@cd = @@mod.definitions.load cmp
   end
      @@mod.definitions.find{|cd|cd.name=~/#{@@last1}?/i}.instances.each{|ci|ci.definition=@@cd}
      @@avant = @@next
      Sketchup.active_model.set_attribute("component","Last",@@next)
   else
   UI.messagebox "#{@@last1} not found."
   end
   end
   
   def rendreunique
	   model=Sketchup.active_model
	   selection=model.selection
	   selection.each do |ent|
   if ent.is_a? Sketchup::ComponentInstance or ent.is_a? Sketchup::Group
	  unique(ent)
   end
   end
   end
   
   def unique(instance)
	   choices=[]
	   if instance.is_a? Sketchup::ComponentInstance
	   instance=instance.make_unique
   end
	   choices=instance.definition.entities
	   choices.each do |ent|
   if ent.is_a? Sketchup::ComponentInstance or ent.is_a? Sketchup::Group
	  unique(ent)
   end
   end
   end   
	
		
if !file_loaded?(__FILE__)

      su_menu = UI.menu("Plugins")

      cc_menu = su_menu.add_submenu(%Q(Teste))

      tb = UI::Toolbar.new(%Q(Teste))

      command1 = UI::Command.new("Change Color"){ Teste.colorchange }

      command1.small_icon = File.join(@@path_to_resources,"add_00.png")

      command1.large_icon = File.join(@@path_to_resources,"add_00.png")

      command1.tooltip = %Q(Change Color)

      command1.status_bar_text = %Q(Change Color)

      command1.menu_text = %Q(Change Color)

      cc_menu.add_item(command1)

      tb.add_item(command1)
		
		
	  command2 = UI::Command.new("Change component"){ Teste.componentchange }

      command2.small_icon = File.join(@@path_to_resources,"add_01.png")

      command2.large_icon = File.join(@@path_to_resources,"add_01.png")

      command2.tooltip = %Q(Change component)

      command2.status_bar_text = %Q(Change component)

      command2.menu_text = %Q(Change component)

      cc_menu.add_item(command2)

      tb.add_item(command2)
	  
	  
	  
	  command3 = UI::Command.new("Figer selection"){ Teste.rendreunique }

      command3.small_icon = File.join(@@path_to_resources,"add_03.png")

      command3.large_icon = File.join(@@path_to_resources,"add_03.png")

      command3.tooltip = %Q(Figer selection)

      command3.status_bar_text = %Q(Figer selection)

      command3.menu_text = %Q(Figer selection)

      cc_menu.add_item(command3)

      tb.add_item(command3)
	  
	  
      tb.restore

      file_loaded(__FILE__)

      end
	  end
	  end

